# coding: utf-8

"""
    LogicMonitor REST API

    LogicMonitor is a SaaS-based performance monitoring platform that provides full visibility into complex, hybrid infrastructures, offering granular performance monitoring and actionable data and insights. logicmonitor_sdk enables you to manage your LogicMonitor account programmatically.  # noqa: E501

    OpenAPI spec version: 1.0.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from logicmonitor_sdk.models.name_and_value import NameAndValue  # noqa: F401,E501


class CollectorGroup(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'user_permission': 'str',
        'num_of_collectors': 'int',
        'auto_balance_instance_count_threshold': 'int',
        'description': 'str',
        'platform': 'str',
        'auto_balance_device_count_threshold': 'int',
        'mismatch_verison': 'bool',
        'auto_balance': 'bool',
        'custom_properties': 'list[NameAndValue]',
        'num_of_hosts': 'int',
        'num_of_instances': 'int',
        'name': 'str',
        'auto_balance_strategy': 'str',
        'create_on': 'int',
        'id': 'int'
    }

    attribute_map = {
        'user_permission': 'userPermission',
        'num_of_collectors': 'numOfCollectors',
        'auto_balance_instance_count_threshold': 'autoBalanceInstanceCountThreshold',
        'description': 'description',
        'platform': 'platform',
        'auto_balance_device_count_threshold': 'autoBalanceDeviceCountThreshold',
        'mismatch_verison': 'mismatchVerison',
        'auto_balance': 'autoBalance',
        'custom_properties': 'customProperties',
        'num_of_hosts': 'numOfHosts',
        'num_of_instances': 'numOfInstances',
        'name': 'name',
        'auto_balance_strategy': 'autoBalanceStrategy',
        'create_on': 'createOn',
        'id': 'id'
    }

    def __init__(self, user_permission=None, num_of_collectors=None, auto_balance_instance_count_threshold=None, description=None, platform=None, auto_balance_device_count_threshold=None, mismatch_verison=None, auto_balance=None, custom_properties=None, num_of_hosts=None, num_of_instances=None, name=None, auto_balance_strategy=None, create_on=None, id=None):  # noqa: E501
        """CollectorGroup - a model defined in Swagger"""  # noqa: E501

        self._user_permission = None
        self._num_of_collectors = None
        self._auto_balance_instance_count_threshold = None
        self._description = None
        self._platform = None
        self._auto_balance_device_count_threshold = None
        self._mismatch_verison = None
        self._auto_balance = None
        self._custom_properties = None
        self._num_of_hosts = None
        self._num_of_instances = None
        self._name = None
        self._auto_balance_strategy = None
        self._create_on = None
        self._id = None
        self.discriminator = None

        if user_permission is not None:
            self.user_permission = user_permission
        if num_of_collectors is not None:
            self.num_of_collectors = num_of_collectors
        if auto_balance_instance_count_threshold is not None:
            self.auto_balance_instance_count_threshold = auto_balance_instance_count_threshold
        if description is not None:
            self.description = description
        if platform is not None:
            self.platform = platform
        if auto_balance_device_count_threshold is not None:
            self.auto_balance_device_count_threshold = auto_balance_device_count_threshold
        if mismatch_verison is not None:
            self.mismatch_verison = mismatch_verison
        if auto_balance is not None:
            self.auto_balance = auto_balance
        if custom_properties is not None:
            self.custom_properties = custom_properties
        if num_of_hosts is not None:
            self.num_of_hosts = num_of_hosts
        if num_of_instances is not None:
            self.num_of_instances = num_of_instances
        self.name = name
        if auto_balance_strategy is not None:
            self.auto_balance_strategy = auto_balance_strategy
        if create_on is not None:
            self.create_on = create_on
        if id is not None:
            self.id = id

    @property
    def user_permission(self):
        """Gets the user_permission of this CollectorGroup.  # noqa: E501

        The permission level of the user that made the API request  # noqa: E501

        :return: The user_permission of this CollectorGroup.  # noqa: E501
        :rtype: str
        """
        return self._user_permission

    @user_permission.setter
    def user_permission(self, user_permission):
        """Sets the user_permission of this CollectorGroup.

        The permission level of the user that made the API request  # noqa: E501

        :param user_permission: The user_permission of this CollectorGroup.  # noqa: E501
        :type: str
        """

        self._user_permission = user_permission

    @property
    def num_of_collectors(self):
        """Gets the num_of_collectors of this CollectorGroup.  # noqa: E501

        The number of Collectors that belong to the group  # noqa: E501

        :return: The num_of_collectors of this CollectorGroup.  # noqa: E501
        :rtype: int
        """
        return self._num_of_collectors

    @num_of_collectors.setter
    def num_of_collectors(self, num_of_collectors):
        """Sets the num_of_collectors of this CollectorGroup.

        The number of Collectors that belong to the group  # noqa: E501

        :param num_of_collectors: The num_of_collectors of this CollectorGroup.  # noqa: E501
        :type: int
        """

        self._num_of_collectors = num_of_collectors

    @property
    def auto_balance_instance_count_threshold(self):
        """Gets the auto_balance_instance_count_threshold of this CollectorGroup.  # noqa: E501


        :return: The auto_balance_instance_count_threshold of this CollectorGroup.  # noqa: E501
        :rtype: int
        """
        return self._auto_balance_instance_count_threshold

    @auto_balance_instance_count_threshold.setter
    def auto_balance_instance_count_threshold(self, auto_balance_instance_count_threshold):
        """Sets the auto_balance_instance_count_threshold of this CollectorGroup.


        :param auto_balance_instance_count_threshold: The auto_balance_instance_count_threshold of this CollectorGroup.  # noqa: E501
        :type: int
        """

        self._auto_balance_instance_count_threshold = auto_balance_instance_count_threshold

    @property
    def description(self):
        """Gets the description of this CollectorGroup.  # noqa: E501

        The description of the Collector Group  # noqa: E501

        :return: The description of this CollectorGroup.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this CollectorGroup.

        The description of the Collector Group  # noqa: E501

        :param description: The description of this CollectorGroup.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def platform(self):
        """Gets the platform of this CollectorGroup.  # noqa: E501


        :return: The platform of this CollectorGroup.  # noqa: E501
        :rtype: str
        """
        return self._platform

    @platform.setter
    def platform(self, platform):
        """Sets the platform of this CollectorGroup.


        :param platform: The platform of this CollectorGroup.  # noqa: E501
        :type: str
        """

        self._platform = platform

    @property
    def auto_balance_device_count_threshold(self):
        """Gets the auto_balance_device_count_threshold of this CollectorGroup.  # noqa: E501


        :return: The auto_balance_device_count_threshold of this CollectorGroup.  # noqa: E501
        :rtype: int
        """
        return self._auto_balance_device_count_threshold

    @auto_balance_device_count_threshold.setter
    def auto_balance_device_count_threshold(self, auto_balance_device_count_threshold):
        """Sets the auto_balance_device_count_threshold of this CollectorGroup.


        :param auto_balance_device_count_threshold: The auto_balance_device_count_threshold of this CollectorGroup.  # noqa: E501
        :type: int
        """

        self._auto_balance_device_count_threshold = auto_balance_device_count_threshold

    @property
    def mismatch_verison(self):
        """Gets the mismatch_verison of this CollectorGroup.  # noqa: E501


        :return: The mismatch_verison of this CollectorGroup.  # noqa: E501
        :rtype: bool
        """
        return self._mismatch_verison

    @mismatch_verison.setter
    def mismatch_verison(self, mismatch_verison):
        """Sets the mismatch_verison of this CollectorGroup.


        :param mismatch_verison: The mismatch_verison of this CollectorGroup.  # noqa: E501
        :type: bool
        """

        self._mismatch_verison = mismatch_verison

    @property
    def auto_balance(self):
        """Gets the auto_balance of this CollectorGroup.  # noqa: E501


        :return: The auto_balance of this CollectorGroup.  # noqa: E501
        :rtype: bool
        """
        return self._auto_balance

    @auto_balance.setter
    def auto_balance(self, auto_balance):
        """Sets the auto_balance of this CollectorGroup.


        :param auto_balance: The auto_balance of this CollectorGroup.  # noqa: E501
        :type: bool
        """

        self._auto_balance = auto_balance

    @property
    def custom_properties(self):
        """Gets the custom_properties of this CollectorGroup.  # noqa: E501

        The custom properties defined for the Collector group  # noqa: E501

        :return: The custom_properties of this CollectorGroup.  # noqa: E501
        :rtype: list[NameAndValue]
        """
        return self._custom_properties

    @custom_properties.setter
    def custom_properties(self, custom_properties):
        """Sets the custom_properties of this CollectorGroup.

        The custom properties defined for the Collector group  # noqa: E501

        :param custom_properties: The custom_properties of this CollectorGroup.  # noqa: E501
        :type: list[NameAndValue]
        """

        self._custom_properties = custom_properties

    @property
    def num_of_hosts(self):
        """Gets the num_of_hosts of this CollectorGroup.  # noqa: E501

        The number of hosts that belong to the group  # noqa: E501

        :return: The num_of_hosts of this CollectorGroup.  # noqa: E501
        :rtype: int
        """
        return self._num_of_hosts

    @num_of_hosts.setter
    def num_of_hosts(self, num_of_hosts):
        """Sets the num_of_hosts of this CollectorGroup.

        The number of hosts that belong to the group  # noqa: E501

        :param num_of_hosts: The num_of_hosts of this CollectorGroup.  # noqa: E501
        :type: int
        """

        self._num_of_hosts = num_of_hosts

    @property
    def num_of_instances(self):
        """Gets the num_of_instances of this CollectorGroup.  # noqa: E501

        The number of instances that belong to the group  # noqa: E501

        :return: The num_of_instances of this CollectorGroup.  # noqa: E501
        :rtype: int
        """
        return self._num_of_instances

    @num_of_instances.setter
    def num_of_instances(self, num_of_instances):
        """Sets the num_of_instances of this CollectorGroup.

        The number of instances that belong to the group  # noqa: E501

        :param num_of_instances: The num_of_instances of this CollectorGroup.  # noqa: E501
        :type: int
        """

        self._num_of_instances = num_of_instances

    @property
    def name(self):
        """Gets the name of this CollectorGroup.  # noqa: E501

        The name of the Collector Group  # noqa: E501

        :return: The name of this CollectorGroup.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this CollectorGroup.

        The name of the Collector Group  # noqa: E501

        :param name: The name of this CollectorGroup.  # noqa: E501
        :type: str
        """
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def auto_balance_strategy(self):
        """Gets the auto_balance_strategy of this CollectorGroup.  # noqa: E501


        :return: The auto_balance_strategy of this CollectorGroup.  # noqa: E501
        :rtype: str
        """
        return self._auto_balance_strategy

    @auto_balance_strategy.setter
    def auto_balance_strategy(self, auto_balance_strategy):
        """Sets the auto_balance_strategy of this CollectorGroup.


        :param auto_balance_strategy: The auto_balance_strategy of this CollectorGroup.  # noqa: E501
        :type: str
        """

        self._auto_balance_strategy = auto_balance_strategy

    @property
    def create_on(self):
        """Gets the create_on of this CollectorGroup.  # noqa: E501

        The time at which the group was created, in epoch format  # noqa: E501

        :return: The create_on of this CollectorGroup.  # noqa: E501
        :rtype: int
        """
        return self._create_on

    @create_on.setter
    def create_on(self, create_on):
        """Sets the create_on of this CollectorGroup.

        The time at which the group was created, in epoch format  # noqa: E501

        :param create_on: The create_on of this CollectorGroup.  # noqa: E501
        :type: int
        """

        self._create_on = create_on

    @property
    def id(self):
        """Gets the id of this CollectorGroup.  # noqa: E501

        The id of the Collector Group  # noqa: E501

        :return: The id of this CollectorGroup.  # noqa: E501
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this CollectorGroup.

        The id of the Collector Group  # noqa: E501

        :param id: The id of this CollectorGroup.  # noqa: E501
        :type: int
        """

        self._id = id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(CollectorGroup, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CollectorGroup):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
