# coding: utf-8

"""
    LogicMonitor REST API

    LogicMonitor is a SaaS-based performance monitoring platform that provides full visibility into complex, hybrid infrastructures, offering granular performance monitoring and actionable data and insights. logicmonitor_sdk enables you to manage your LogicMonitor account programmatically.  # noqa: E501

    OpenAPI spec version: 1.0.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from logicmonitor_sdk.models.auto_discovery_method import AutoDiscoveryMethod  # noqa: F401,E501


class AzureBillingDiscoveryMethod(AutoDiscoveryMethod):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'name': 'str',
        'azure_billing_type': 'str'
    }

    attribute_map = {
        'name': 'name',
        'azure_billing_type': 'azureBillingType'
    }

    def __init__(self, name=None, azure_billing_type=None):  # noqa: E501
        """AzureBillingDiscoveryMethod - a model defined in Swagger"""  # noqa: E501

        self._name = None
        self._azure_billing_type = None
        self.discriminator = None

        self.name = name
        self.azure_billing_type = azure_billing_type

    @property
    def name(self):
        """Gets the name of this AzureBillingDiscoveryMethod.  # noqa: E501


        :return: The name of this AzureBillingDiscoveryMethod.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this AzureBillingDiscoveryMethod.


        :param name: The name of this AzureBillingDiscoveryMethod.  # noqa: E501
        :type: str
        """
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def azure_billing_type(self):
        """Gets the azure_billing_type of this AzureBillingDiscoveryMethod.  # noqa: E501


        :return: The azure_billing_type of this AzureBillingDiscoveryMethod.  # noqa: E501
        :rtype: str
        """
        return self._azure_billing_type

    @azure_billing_type.setter
    def azure_billing_type(self, azure_billing_type):
        """Sets the azure_billing_type of this AzureBillingDiscoveryMethod.


        :param azure_billing_type: The azure_billing_type of this AzureBillingDiscoveryMethod.  # noqa: E501
        :type: str
        """
        if azure_billing_type is None:
            raise ValueError("Invalid value for `azure_billing_type`, must not be `None`")  # noqa: E501

        self._azure_billing_type = azure_billing_type

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(AzureBillingDiscoveryMethod, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AzureBillingDiscoveryMethod):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
