# coding: utf-8

"""
    LogicMonitor REST API

    LogicMonitor is a SaaS-based performance monitoring platform that provides full visibility into complex, hybrid infrastructures, offering granular performance monitoring and actionable data and insights. logicmonitor_sdk enables you to manage your LogicMonitor account programmatically.  # noqa: E501

    OpenAPI spec version: 1.0.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from logicmonitor_sdk.models.auto_discovery_method import AutoDiscoveryMethod  # noqa: F401,E501


class JDBCAutoDiscoveryMethod(AutoDiscoveryMethod):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'name': 'str',
        'query': 'str',
        'ports': 'str',
        'type': 'str',
        'separator': 'str',
        'url': 'str',
        'sid': 'str'
    }

    attribute_map = {
        'name': 'name',
        'query': 'query',
        'ports': 'ports',
        'type': 'type',
        'separator': 'separator',
        'url': 'url',
        'sid': 'sid'
    }

    def __init__(self, name=None, query=None, ports=None, type=None, separator=None, url=None, sid=None):  # noqa: E501
        """JDBCAutoDiscoveryMethod - a model defined in Swagger"""  # noqa: E501

        self._name = None
        self._query = None
        self._ports = None
        self._type = None
        self._separator = None
        self._url = None
        self._sid = None
        self.discriminator = None

        self.name = name
        self.query = query
        self.ports = ports
        self.type = type
        if separator is not None:
            self.separator = separator
        self.url = url
        if sid is not None:
            self.sid = sid

    @property
    def name(self):
        """Gets the name of this JDBCAutoDiscoveryMethod.  # noqa: E501


        :return: The name of this JDBCAutoDiscoveryMethod.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this JDBCAutoDiscoveryMethod.


        :param name: The name of this JDBCAutoDiscoveryMethod.  # noqa: E501
        :type: str
        """
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def query(self):
        """Gets the query of this JDBCAutoDiscoveryMethod.  # noqa: E501


        :return: The query of this JDBCAutoDiscoveryMethod.  # noqa: E501
        :rtype: str
        """
        return self._query

    @query.setter
    def query(self, query):
        """Sets the query of this JDBCAutoDiscoveryMethod.


        :param query: The query of this JDBCAutoDiscoveryMethod.  # noqa: E501
        :type: str
        """
        if query is None:
            raise ValueError("Invalid value for `query`, must not be `None`")  # noqa: E501

        self._query = query

    @property
    def ports(self):
        """Gets the ports of this JDBCAutoDiscoveryMethod.  # noqa: E501


        :return: The ports of this JDBCAutoDiscoveryMethod.  # noqa: E501
        :rtype: str
        """
        return self._ports

    @ports.setter
    def ports(self, ports):
        """Sets the ports of this JDBCAutoDiscoveryMethod.


        :param ports: The ports of this JDBCAutoDiscoveryMethod.  # noqa: E501
        :type: str
        """
        if ports is None:
            raise ValueError("Invalid value for `ports`, must not be `None`")  # noqa: E501

        self._ports = ports

    @property
    def type(self):
        """Gets the type of this JDBCAutoDiscoveryMethod.  # noqa: E501


        :return: The type of this JDBCAutoDiscoveryMethod.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this JDBCAutoDiscoveryMethod.


        :param type: The type of this JDBCAutoDiscoveryMethod.  # noqa: E501
        :type: str
        """
        if type is None:
            raise ValueError("Invalid value for `type`, must not be `None`")  # noqa: E501

        self._type = type

    @property
    def separator(self):
        """Gets the separator of this JDBCAutoDiscoveryMethod.  # noqa: E501


        :return: The separator of this JDBCAutoDiscoveryMethod.  # noqa: E501
        :rtype: str
        """
        return self._separator

    @separator.setter
    def separator(self, separator):
        """Sets the separator of this JDBCAutoDiscoveryMethod.


        :param separator: The separator of this JDBCAutoDiscoveryMethod.  # noqa: E501
        :type: str
        """

        self._separator = separator

    @property
    def url(self):
        """Gets the url of this JDBCAutoDiscoveryMethod.  # noqa: E501


        :return: The url of this JDBCAutoDiscoveryMethod.  # noqa: E501
        :rtype: str
        """
        return self._url

    @url.setter
    def url(self, url):
        """Sets the url of this JDBCAutoDiscoveryMethod.


        :param url: The url of this JDBCAutoDiscoveryMethod.  # noqa: E501
        :type: str
        """
        if url is None:
            raise ValueError("Invalid value for `url`, must not be `None`")  # noqa: E501

        self._url = url

    @property
    def sid(self):
        """Gets the sid of this JDBCAutoDiscoveryMethod.  # noqa: E501


        :return: The sid of this JDBCAutoDiscoveryMethod.  # noqa: E501
        :rtype: str
        """
        return self._sid

    @sid.setter
    def sid(self, sid):
        """Sets the sid of this JDBCAutoDiscoveryMethod.


        :param sid: The sid of this JDBCAutoDiscoveryMethod.  # noqa: E501
        :type: str
        """

        self._sid = sid

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(JDBCAutoDiscoveryMethod, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, JDBCAutoDiscoveryMethod):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
