# coding: utf-8

"""
    LogicMonitor REST API

    LogicMonitor is a SaaS-based performance monitoring platform that provides full visibility into complex, hybrid infrastructures, offering granular performance monitoring and actionable data and insights. logicmonitor_sdk enables you to manage your LogicMonitor account programmatically.  # noqa: E501

    OpenAPI spec version: 1.0.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from logicmonitor_sdk.models.widget_token_inheritance import WidgetTokenInheritance  # noqa: F401,E501


class WidgetToken(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'inherit_list': 'list[WidgetTokenInheritance]',
        'name': 'str',
        'type': 'str',
        'value': 'str'
    }

    attribute_map = {
        'inherit_list': 'inheritList',
        'name': 'name',
        'type': 'type',
        'value': 'value'
    }

    def __init__(self, inherit_list=None, name=None, type=None, value=None):  # noqa: E501
        """WidgetToken - a model defined in Swagger"""  # noqa: E501

        self._inherit_list = None
        self._name = None
        self._type = None
        self._value = None
        self.discriminator = None

        if inherit_list is not None:
            self.inherit_list = inherit_list
        if name is not None:
            self.name = name
        if type is not None:
            self.type = type
        if value is not None:
            self.value = value

    @property
    def inherit_list(self):
        """Gets the inherit_list of this WidgetToken.  # noqa: E501


        :return: The inherit_list of this WidgetToken.  # noqa: E501
        :rtype: list[WidgetTokenInheritance]
        """
        return self._inherit_list

    @inherit_list.setter
    def inherit_list(self, inherit_list):
        """Sets the inherit_list of this WidgetToken.


        :param inherit_list: The inherit_list of this WidgetToken.  # noqa: E501
        :type: list[WidgetTokenInheritance]
        """

        self._inherit_list = inherit_list

    @property
    def name(self):
        """Gets the name of this WidgetToken.  # noqa: E501

        This is the name of the parent group of devices, if there is one established  # noqa: E501

        :return: The name of this WidgetToken.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this WidgetToken.

        This is the name of the parent group of devices, if there is one established  # noqa: E501

        :param name: The name of this WidgetToken.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def type(self):
        """Gets the type of this WidgetToken.  # noqa: E501


        :return: The type of this WidgetToken.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this WidgetToken.


        :param type: The type of this WidgetToken.  # noqa: E501
        :type: str
        """

        self._type = type

    @property
    def value(self):
        """Gets the value of this WidgetToken.  # noqa: E501

        this is the name of the child group of devices, if there is one  # noqa: E501

        :return: The value of this WidgetToken.  # noqa: E501
        :rtype: str
        """
        return self._value

    @value.setter
    def value(self, value):
        """Sets the value of this WidgetToken.

        this is the name of the child group of devices, if there is one  # noqa: E501

        :param value: The value of this WidgetToken.  # noqa: E501
        :type: str
        """

        self._value = value

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(WidgetToken, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, WidgetToken):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
